<?php
namespace Teknisa\EST\Modules\EstoqueCego\Factories;

use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Est96000DivergenciasInventarioCegoFactory {
    protected $connection;
    protected $entityManager;

    public function __construct ($entityManager) {
        $this->connection = $entityManager->getConnection();
		$this->entityManager = $entityManager;
    }
    
    public function getParperdivestceg($params) {
        $sql = "SELECT VRPERDIVESTCEG
                  FROM PARPERDIVESTCEG
                 WHERE CDFILIAL = :CDFILIAL
                   AND :CDPRODUTO BETWEEN CDPRODUTO AND CDPRODUTO||'zzzzzzzzzz'
                 ORDER BY CDPRODUTO DESC";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetch();
    }
    
    public function getCardapioInfo($params) {
        $sql = "SELECT C.NRCARDAPIO, R.CDFILANCESTQ, R.NRLANCESTQ
                  FROM CARDADIA C, RETIRADA R
                 WHERE C.CDFILIAL    = :CDFILIAL
                   AND C.CDSERVFILI  = :CDSERVFILI
                   AND C.DTCARDAPIO  = :DTCARDAPIO
                   AND (C.NRCARDAPIO = :NRCARDAPIO OR :NRCARDAPIO = 'T')
                   AND R.CDFILIAL = C.CDFILIAL
                   AND R.NRCARDAPIO = C.NRCARDAPIO";

        $query = $this->connection->prepare($sql);
        $query->execute($params);

        return $query->fetchAll();
    }
    
}