var Est96000_DivergenciasInventarioCego_Controller = function(metaDataFactory, templateManager, ScreenService, MessageService, General, EstUtil, ZhFilterPreferences, Est96000_DivergenciasInventarioCego_Services) {

    let IDUTILALMOX, IDUTILLCESTQ, IDUTILLOTE, DTPROCESSA, IDINVESTCEGO;

    // Open initial screen filter with default values
    this.onOpenFilter = function(widget) {
        let rowsToSet = {};
        Est96000_DivergenciasInventarioCego_Services.getFilialLogada().then(success => {
            rowsToSet.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            rowsToSet.CDFILIAL = success.dataset.filial[0].CDFILIAL;

            Est96000_DivergenciasInventarioCego_Services.getParamFilialData().then(success => {
                const paramFilialData = success.dataset.paramfilial[0];
                
                DTPROCESSA = paramFilialData.DTPROCESSA;
                
                const dtInicial = DTPROCESSA;
                const dtFinal = moment().endOf('month').format('DD/MM/YYYY');

                rowsToSet.DTCONTAGEM = { "start": dtInicial, "end": dtFinal, "formattedStart": dtInicial, "formattedEnd": dtFinal };

                ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(success => {
                    templateManager.container.getActiveWidget('zhFilterPreferencesSelectConditions').getField("NMFILIAL").reload();
                });

            });
        });
    };

    // Creates parameter bag to send to backend
    this.setFilterParams = function(widget, preference = null) {
        const row = preference.FILTER_ROW;

        let startDate = row.DTCONTAGEM.start;
        let endDate = row.DTCONTAGEM.end;
        let CDFILIAL = row.CDFILIAL;

        let params = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": CDFILIAL
            },
            {
                "name": "IDSITESTCEGO",
                "operator": "=",
                "value": "AP"
            },
            {
                "name": "DTCONTAGEM",
                "operator": "BETWEEN",
                "value": [startDate, endDate]
            }
        ];

        widget.dataSourceFilter = params;
        widget.reload();
    };

    // This opens swipe details without change widget mode to view
    this.onOpenDetail = function(widget) {
        let InventoryTabbed = templateManager.container.getWidget('InventoryTabbed');
        ScreenService.openSwipe(InventoryTabbed);
        templateManager.container.getWidget('writeOffItemGrid').reload();
    };

    // This function saves approved inventories or send them back to retyping situation 
    this.processBeforeReport = function(args) {
        const widget = args.owner;

        let writeOffLabel = "Relatório de Divergências do Estoque Cego - Itens a Baixar";
        let controlLabel = "Relatório de Divergências do Estoque Cego - Itens a Controlar";

        args.e.metadata.title = widget.name === 'writeOffItemGrid' ? writeOffLabel : controlLabel;
    };

    // Manages actions functionalities according to buttons
    this.actionsManagementHandler = function(widget, action) {

        widget = widget.name == 'writeOffItemGrid' ? widget : templateManager.container.getWidget('writeOffItemGrid');
        const rows = widget.dataSource.data;
        const ignoredKeys = ["__rightActions", "__leftActions", "__createdLocal", "__index", "$error"];

        switch (action) {
            case 'accept':

                if (rows.length > 0) {
                    MessageService.confirmMessageByCode('ACCEPT_CONFIRMATION').then(_ => {
                        Est96000_DivergenciasInventarioCego_Services.actionsManagementHandler(rows, true, action);

                    });
                }
                else {
                    MessageService.confirmMessageByCode('OPERATION_CONFIRMATION').then(_ => {
                        Est96000_DivergenciasInventarioCego_Services.actionsManagementHandler(rows, false, action);

                    });
                }

                break;
            case 'refuse':
                MessageService.confirmMessageByCode('REFUSE_CONFIRMATION').then(_ => {
                    const refusePopUp = templateManager.container.getWidget('refuseInventoryPopUp');
                    const inventoryRow = widget.getParent().getParent().currentRow;

                    ScreenService.openPopup(refusePopUp).then(_ => {
                        refusePopUp.currentRow = Util.clone(inventoryRow, ignoredKeys);
                        refusePopUp.currentRow.NMFILIAL = EstUtil.getFieldValue('NMFILIAL', 'inventoryGrid', true);
                        refusePopUp.currentRow.DSOBSRECAJUST = '';
                        refusePopUp.getField('NMFILIAL').reload();
                    });

                });
                break;

            case 'adjust':
                break;
            default:
                break;

        }
    };

    // Controls actions visibility on enter widget
    this.actionsVisibility = function(widget) {
        const actions = widget.getActions();
        const InventoryRow = widget.getParent().getParent().currentRow;

        Est96000_DivergenciasInventarioCego_Services.getGroupOperatorInfo().then((success) => {
            const dataReturn = success.dataset.autgrupop_grupoper_opergrupop;
            const ValidateGroupOperator = (OperatorGroupInfo, action) => {
                if (action.name == 'adjust') {
                    return OperatorGroupInfo.filter((item) => {
                        return item.IDAUTGRUPOP === 'GAUD';
                    });
                }
                else {
                    return OperatorGroupInfo.filter((item) => {
                        return item.IDAUTGRUPOP === 'GGER' || item.IDAUTGRUPOP === 'GAUD';
                    });
                }
            };

            actions.forEach(action => {
                switch (action.name) {
                    case 'accept':
                        if (
                            ValidateGroupOperator(dataReturn, action).length != 0 &&
                            InventoryRow.IDSITUACEITEINV != "P" &&
                            (DTPROCESSA > InventoryRow.DTCONTAGEM &&
                            DTPROCESSA <= InventoryRow.DTDIAUTIL)
                        ) {
                            General.setEnableAction('accept',widget.name);
                            General.setEnableAction('refuse',widget.name);
                            General.setEnableAction('adjust',widget.name);
                        }
                        break;

                    case 'adjust':
                        
                        if (
                            ValidateGroupOperator(dataReturn, action).length != 0 &&
                            (IDINVESTCEGO = "S" &&
                            InventoryRow.IDINVGERAAJUSTE != "S" &&
                            InventoryRow.IDSITUACEITEINV != "R") &&
                            (DTPROCESSA > InventoryRow.DTCONTAGEM &&
                            DTPROCESSA <= InventoryRow.DTDIAUTIL)
                        ) {
                            General.setEnableAction('adjust',widget.name);
                            General.setDisableAction('accept'.name,widget.name);
                            General.setDisableAction('refuse'.name,widget.name);
                        }
                        break;
                    default:
                        //go to next action in loop
                        break;

                }
            });
        });
    };

    //this function closes the refuse inventory pop up
    this.onClosePopUpRefuseInventory = function(widget) {
        const writeOffGrid = templateManager.container.getWidget('writeOffItemGrid');
        ScreenService.closePopup();
        writeOffGrid.activate();
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Est96000_DivergenciasInventarioCego_Controller', Est96000_DivergenciasInventarioCego_Controller);
});
